      SUBROUTINE MARGEV(V2,V,N,NP,IP,JV)
      IMPLICIT NONE
      INCLUDE 'mpif.h'
      INTEGER N
      INTEGER NP,IP,JV
      COMPLEX*16 V2(N,N),V(N,JV)
      INTEGER JVBLK(NP+1)
      INTEGER JMOD,JGB
      INTEGER I,J,JS,JE,J1,ISIZE,ISEN,JT
      INTEGER ITAG,REQ_S,REQ_R,IERR
      INTEGER SWK(MPI_STATUS_SIZE),RWK(MPI_STATUS_SIZE)
      COMPLEX*16,ALLOCATABLE :: VREC(:,:)
C
      ALLOCATE(VREC(N,JV))
      ITAG=1
      JGB=N/NP
      JMOD=MOD(N,NP)
C
      JVBLK(1)=1
      DO J=1,NP-1
         IF(J-1 .LT. JMOD)THEN
            JT=1
         ELSE
            JT=0
         END IF
         IF(JGB+JT .GT. 0)THEN
            JVBLK(J+1)=JVBLK(J)+JGB+JT
         ELSE
            JVBLK(J+1)=N+1
         END IF
      ENDDO
      JVBLK(NP+1)=N+1
C
      ISIZE=N*JV
      DO ISEN=0,NP-1
         IF(IP .EQ. ISEN) THEN
            CALL MPI_ISEND(V,ISIZE,MPI_DOUBLE_COMPLEX,
     *                     0,ITAG,MPI_COMM_WORLD,REQ_S,IERR)
         END IF
         IF(IP .EQ. 0) THEN
            CALL MPI_IRECV(VREC,ISIZE,MPI_DOUBLE_COMPLEX,
     *                    ISEN,ITAG,MPI_COMM_WORLD,REQ_R,IERR)
            CALL MPI_WAIT(REQ_R,RWK,IERR)
            JS=JVBLK(ISEN+1)
            IF(JS .GT. N)THEN
               GO TO 2000
            END IF
            JE=JVBLK(ISEN+2)-1
            DO J=JS,JE
               J1=J-JS+1
               DO I=1,N
                  V2(I,J)=VREC(I,J1)
               ENDDO
            ENDDO
         END IF
 2000    CONTINUE
         IF(IP .EQ. ISEN)THEN
            CALL MPI_WAIT(REQ_S,SWK,IERR)
         END IF
         CALL MPI_BARRIER(MPI_COMM_WORLD,IERR)
      ENDDO
      DEALLOCATE(VREC)
C
      RETURN
      END
