      PROGRAM TEST_GEN
      IMPLICIT REAL*8(a-h,o-z)
      INCLUDE 'mpif.h'
      INTEGER N,NP,NB,IP,I,K,J,INCX,INFO
      CHARACTER*1 MAJOR
      REAL*8, ALLOCATABLE :: B(:)
      COMPLEX*16, ALLOCATABLE :: A(:),A2(:),V2(:,:)
C
      CALL MPI_INIT(IERR)
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
C
      N=300
      NB=8
      INCX=10
CCCCCCCCCCCCC MAJOR: C or R
      MAJOR='R'
C
      ALLOCATE(A(N*(N+1)/2),B(N*(N+1)/2),A2(N),V2(N,INCX))
      CALL MATGEN_HAMIL(A,N)
      CALL MATGEN_NORM(B,N)
      CALL PZDIAG_GEN(MAJOR,IP,N,A,B,NP,NB,A2,V2,INCX,INFO)
C
      IF (IP.EQ.0) THEN
      CALL RESID_G(N,A,B,A2,V2,INCX)
      END IF
      DEALLOCATE(A,B,A2,V2)
      CALL MPI_FINALIZE(IERR)
C
      STOP
      END
