      SUBROUTINE QR(N,ZG,ZX,D,E)
C -------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Y)
      IMPLICIT COMPLEX*16(Z)
      REAL*8 TOLER,ANORM,EPS
      DIMENSION ZG(N),ZX(N,*),ZWK(N+1,5)
      COMPLEX*16 D(N),E(N)
C ---<DIAGONALIZATION OF COMPLEX MATRIX>-----------------------------
C     DIAGONALIZATION OF TRD SYMMETRIC COMPLEX MATRIX
C                                  VECTOR OF J-TH BASE ZX(I,J)
C                                  ZG(ND),ZX(ND,ND) ND >= N
C                                  ZWK(NW,5) WORK NW >= ND+1
C     NW=ND+1
C     TOLER IS THE RELATIVE PRECISION OF THE MACHINE
C
      TOLER=1.5D-60
      DO I=1,N
         ZWK(I,1)=D(I)
         ZWK(I+1,2)=E(I)
      ENDDO
C
C      WRITE(6,*) '*** TRIDIAGONAL MATRIX ***'
C      DO I=1,N
C         WRITE(6,*) I,'     DIAG=',ZWK(I,1)
C         WRITE(6,*) I,' SUB-DIAG=',ZWK(I+1,2)
C      ENDDO
      ANORM=0.D0
      ZTA = (0.D0,0.D0)
      ZWK(N+1,2) = (0.D0,0.D0)
      DO 110 K=1,N
      ZT=ABS(ZWK(K,1))+ZTA
      TA=ABS(ZWK(K+1,2))
      ZT=ZT+TA
      IF(DBLE(ZT).GT.ANORM) ANORM=DBLE(ZT)
  110 CONTINUE
      EPS = ANORM*TOLER
C     WRITE(6,*) '--- TRIDIAGONAL NORM =',ANORM
C
      ZAMU=(0.D0,0.D0)
      ZWK(1,2)=(0.D0,0.D0)
      M=N
   15 IF(M.EQ.0) GO TO 21
      I = M-1
      M1= I
      K = I
      IF(ABS(ZWK(K+1,2)).GT.EPS) GO TO 16
      ZAMU=(0.D0,0.D0)
      M = K
      GO TO 15
   16 I=I-1
      IF(ABS(ZWK(I+1,2)).LE.EPS.OR.I.EQ.0) GO TO 18
      K=I
      GO TO 16
   18 ZRAMDA=(0.0D0,0.0D0)
      IF(ABS(ZWK(M,1)-ZAMU).LT.0.5D0*ABS(ZWK(M,1)).OR.M1.EQ.K)
     &  ZRAMDA=ZWK(M,1)+0.5D0*ZWK(M1+1,2)
      ZAMU = ZWK(M,1)
C      WRITE(6,*) '  ZRAMDA=',ZRAMDA
      ZWK(K,1) = ZWK(K,1) - ZRAMDA
      ZBETA = ZWK(K+1,2)
C
      DO 19 J=K, M1
      ZA0=ZWK(J,1)
      ZA1=ZWK(J+1,1)-ZRAMDA
      ZB0=ZWK(J+1,2)
      ZT=SQRT(ZA0*ZA0+ZBETA*ZBETA)
      ZCOSINE=ZA0/ZT
      ZWK(J,4)=ZCOSINE
      ZSINE=ZBETA/ZT
      ZWK(J,5)=ZSINE
      ZWK(J,1)=ZCOSINE*ZA0+ZSINE*ZBETA
      ZWK(J+1,1)=-ZSINE*ZB0+ZCOSINE*ZA1
      ZWK(J+1,2)=ZCOSINE*ZB0+ZSINE*ZA1
      ZBETA=ZWK(J+2,2)
      ZWK(J+2,2)=ZCOSINE*ZBETA
   19 ZWK(J+2,3)=ZSINE*ZBETA
      ZWK(K,2)  =(0.D0,0.D0)
      ZWK(K+1,3)=(0.D0,0.D0)
C
      DO 20 J=K,M1
      ZSINE=ZWK(J,5)
      ZCOSINE=ZWK(J,4)
      ZA0=ZWK(J,1)
      ZB0=ZWK(J+1,2)
      ZWK(J,2)=ZWK(J,2)*ZCOSINE+ZWK(J+1,3)*ZSINE
      ZWK(J,1)=ZA0*ZCOSINE+ZB0*ZSINE+ZRAMDA
      ZWK(J+1,2)=-ZA0*ZSINE+ZB0*ZCOSINE
      ZWK(J+1,1)=ZWK(J+1,1)*ZCOSINE
      DO 20 I=1,N
      ZX0=ZX(I,J)
      ZX1=ZX(I,J+1)
      ZX(I,J)=ZX0*ZCOSINE+ZX1*ZSINE
   20 ZX(I,J+1)=-ZX0*ZSINE+ZX1*ZCOSINE
      ZWK(M,1)=ZWK(M,1)+ZRAMDA
      GO TO 15
   21 DO 120 M=1,N
  120 ZG(M)=ZWK(M,1)
C
      RETURN
      END
