      SUBROUTINE RESID_G(N,ZZ,BB,ZG,ZX,INCX)
      IMPLICIT REAL*8(A-H,O-Y)
      IMPLICIT COMPLEX*16(Z)
      DIMENSION ZG(N),ZX(N,INCX)
      DIMENSION ZZ(N*(N+1)/2),BB(N*(N+1)/2)
C
      COMPLEX*16 CWK(N)
      COMPLEX*16 CSUM
      COMPLEX*16 S2
C
C+++++CHECK1(NORMALIZE)
      SMAX=0.0D0
      SMIN=2.0D0
      DO K=1,INCX
         S=0.0D0
         DO I=1,N
         DO II=1,N
              IF(I .GE. II)THEN
            S=S+DREAL(ZX(I,K)*DCMPLX(BB(I*(I-1)/2+II),0.d0)*ZX(II,K))
              ELSE IF(I .LT. II)THEN
            S=S+DREAL(ZX(I,K)*DCMPLX(BB(II*(II-1)/2+I),0.d0)*ZX(II,K))
              END IF
         END DO
         END DO
         S=DSQRT(S)
         IF (S.GT.SMAX) SMAX=S
         IF (S.LT.SMIN) SMIN=S
      END DO
      WRITE(6,*) 'MAX. NORMALIZE NORM =',SMAX
      WRITE(6,*) 'MIN. NORMALIZE NORM =',SMIN
C+++++CHECK2(UNITARY)
      SMAX=0.0D0
      DO K=1,INCX
      DO J=K+1,INCX
         S=0.0D0
         DO I=1,N
         DO II=1,N
              IF(I .GE. II)THEN
            S=S+ZX(I,J)*BB(I*(I-1)/2+II)*ZX(II,K)
              ELSE IF(I .LT. II)THEN
            S=S+ZX(I,J)*BB(II*(II-1)/2+I)*ZX(II,K)
              END IF
         END DO
         END DO
         S=DSQRT(ABS(S))
         IF (S.GT.SMAX) SMAX=S
      END DO
      END DO
      WRITE(6,*) 'MAX. UNITARY NORM =',SMAX
C
      RMAX=-1.0D5
      KMAX=0
      DO K=1,INCX
         DO I=1,N
            CSUM=DCMPLX(0.0D0,0.0D0)
            DO J=1,N
              IF(I .GE. J)THEN
               CSUM=CSUM+ZZ(I*(I-1)/2+J)*ZX(J,K)
              ELSE IF(I .LT. J)THEN
               CSUM=CSUM+ZZ(J*(J-1)/2+I)*ZX(J,K)
              END IF
            END DO
            CWK(I)=CSUM
         END DO
         S2=0.0D0
         DO I=1,N
            S3=0.0D0
          DO II=1,N
              IF(I .GE. II)THEN
            S3=S3+BB(I*(I-1)/2+II)*ZX(II,K)
              ELSE IF(I .LT. II)THEN
            S3=S3+BB(II*(II-1)/2+I)*ZX(II,K)
              END IF
          END DO
            CWK(I)=ZG(K)*S3-CWK(I)
            S2=S2+CWK(I)*CONJG(CWK(I))
         END DO
         RS1=CDABS(ZG(K))
         RS2=DSQRT(DREAL(S2))
CCCC         WRITE(6,*) 'COMPLEX RELATIVE RESID=',K,RS2/RS1
         IF(RS2/RS1 .GE. RMAX)THEN
            RMAX=RS2/RS1
            KMAX=K
         END IF
      END DO
      WRITE(6,*)'==============================='
      WRITE(6,*)'MAX COMPLEX RELATIVE RESID=',KMAX,RMAX
      WRITE(6,*)'==============================='
C
      RETURN
      END
